var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { getQueryString, isLangCodeSupported, getError } from './utils';
import { LANGUAGE_NOT_SOPPORTED } from './errorCodes';
import { detect } from './detect';
import getTk from './getTk';
export var audio = function (_a) {
    var text = _a.text, _b = _a.from, from = _b === void 0 ? '' : _b, _c = _a.com, com = _c === void 0 ? true : _c;
    return __awaiter(void 0, void 0, void 0, function () {
        var _d, url, arr, i, params, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    if (!text) {
                        return [2 /*return*/];
                    }
                    _d = from;
                    if (_d) return [3 /*break*/, 2];
                    return [4 /*yield*/, detect(text, com)];
                case 1:
                    _d = (_f.sent());
                    _f.label = 2;
                case 2:
                    from = _d;
                    if (!isLangCodeSupported(from)) {
                        throw getError(LANGUAGE_NOT_SOPPORTED);
                    }
                    url = "https://translate.google." + (com ? 'com' : 'cn') + "/translate_tts";
                    arr = getTextArray(text);
                    i = 0;
                    _f.label = 3;
                case 3:
                    if (!(i < arr.length)) return [3 /*break*/, 6];
                    _e = {
                        client: 'webapp',
                        ie: 'UTF-8',
                        prev: 'input',
                        total: 1,
                        idx: 0,
                        tl: from,
                        textlen: arr[i].length
                    };
                    return [4 /*yield*/, getTk(arr[i], com)];
                case 4:
                    params = (_e.tk = _f.sent(),
                        _e.q = encodeURIComponent(arr[i]),
                        _e);
                    arr[i] = url + getQueryString(params);
                    _f.label = 5;
                case 5:
                    ++i;
                    return [3 /*break*/, 3];
                case 6: return [2 /*return*/, arr];
            }
        });
    });
};
var MAX_TEXT_LENGTH = 200;
var getTextArray = function (text) {
    var arr = [];
    var textArr = [];
    while (text) {
        var index = text.search(/\.|。|\?|？|,|，|:|：|;|；|\s|\n/g);
        if (index >= 0) {
            textArr.push(text.substr(0, index + 1));
            text = text.substr(index + 1, text.length);
        }
        else {
            textArr.push(text);
            break;
        }
    }
    textArr.reduce(function (total, value, index) {
        var length = total.length, str = total.str;
        if (length + value.length <= MAX_TEXT_LENGTH) {
            length += value.length;
            str += value;
        }
        else {
            str && arr.push(str);
            if (value.length > MAX_TEXT_LENGTH) {
                while (value.length > MAX_TEXT_LENGTH) {
                    arr.push(value.substr(0, MAX_TEXT_LENGTH));
                    value = value.substr(MAX_TEXT_LENGTH, value.length);
                }
            }
            length = value.length;
            str = value;
        }
        (index === textArr.length - 1 && str) && arr.push(str);
        return { length: length, str: str };
    }, { length: 0, str: '' });
    return arr;
};
